#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>

#define USEREMAIL "root"
#define SENDMAIL "/usr/sbin/sendmail -t"

extern int errno;
void error_handler(char *,int);
void warn(char*,char*);

#define DELAYTIME 10
#define CONFIGFILE "/etc/nannie.cfg"

/* 
    Basically, we want to get the list of files in, then start
    scanning through 
*/

int main() {
    typedef struct tever {
        char *fname;
		struct stat *info;
        struct tever *next;
    } f;
	struct stat *tmp = (struct stat *) malloc (sizeof(struct stat));

    f *begin=NULL;
    f *p=NULL;
    char *buffer=(char *) malloc (sizeof(char) * 256);
    int i,pid;
    FILE *filehandle;

	filehandle=fopen(CONFIGFILE,"r");
	if(!filehandle && errno) {
		error_handler("fopen",errno);
		exit(-1);
	}

	while(fgets(buffer,255,filehandle)) {
		i=strlen(buffer)-1;
		buffer[i]='\0';
		i=strlen(buffer);

		if(!begin) {
			begin=(f *) malloc (sizeof(f));
			p=begin;
		} else {
			p->next=(f *) malloc (sizeof(f));
			p=p->next;
		}
		p->next=NULL;
		p->info=NULL;

		p->fname=(char *) malloc (sizeof(char) * (strlen(buffer) + 1));
		strcpy(p->fname,buffer);
	}

	if(errno) {
		error_handler("fgets",errno);
		exit(-1);
	}
	fclose(filehandle);

	/* Now we need to go through and get initial statistics on the files */
	p=begin;
	while(p) {
		if(!p->info)
			p->info=(struct stat *) malloc(sizeof(struct stat));
		if(stat(p->fname,p->info)) {
			error_handler("stat",errno);
			exit(-1);
		}
		p=p->next;
	}

	pid=fork();
	if(pid)
		exit(0);

	for(;;) {
		sleep(DELAYTIME);
		p=begin;
		while(p) {
			stat(p->fname,tmp);

			if(tmp->st_ino != p->info->st_ino) {
				warn("Inode", p->fname);
				p->info->st_ino = tmp->st_ino;
			} 

			if(tmp->st_mode != p->info->st_mode) {
				warn("file mode", p->fname);
				p->info->st_mode = tmp->st_mode;
			}

			if(tmp->st_nlink != p->info->st_nlink) {
				warn("hard link", p->fname);
				p->info->st_nlink = tmp->st_nlink;
			}

			if(tmp->st_uid != p->info->st_uid) {
				warn("uid", p->fname);
				p->info->st_uid = tmp->st_uid;
			}

			if(tmp->st_gid != p->info->st_gid) {
				warn("gid", p->fname);
				p->info->st_gid = tmp->st_gid;
			}

			if(tmp->st_size != p->info->st_size) {
				warn("size", p->fname);
				p->info->st_size = tmp->st_size;
			}

			if(tmp->st_mtime != p->info->st_mtime) {
				warn("modification time", p->fname);
				p->info->st_mtime = tmp->st_mtime;
			}

			if(tmp->st_ctime != p->info->st_ctime) {
				warn("change time", p->fname);
				p->info->st_ctime = tmp->st_ctime;
			}
			p=p->next;
		}
	}

	return 0;
}


void error_handler (char *call, int en) {
	/*printf("Call is \"%s\" and errno is \"%d\".\n",call,en);*/
}

void warn (char *item, char *filename) {
	FILE *mail;
	char *message=(char *) malloc (sizeof(char) * (strlen(item) + strlen(filename) + 29));
	mail=popen(SENDMAIL,"w");
	fputs("From The Nannie\n",mail);
	fputs("To: egon@tradeservices.com\n",mail);
	
	strcpy(message,"Subject: Nannie noticed ");
	strcat(message,filename);
	strcat(message,"\n\n");
	fputs(message,mail);

/*	printf("\tThe %s value of %s has changed.\n",item,filename);*/
	strcpy(message,"The ");
	strcat(message,item);
	strcat(message," value of ");
	strcat(message,filename);
	strcat(message," has changed.\n");
	fputs(message,mail);

	pclose(mail);
}
